/**
  * This file was generated from model [WriteController] on [Sun Apr 27 17:19:14 CDT 2008].
  * Do not change content of this file.
  */
package org.cleversafe.layer.grid.smartcontroller;

import java.io.IOException;
import java.util.*;

import org.apache.commons.lang.BooleanUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.evelopers.common.exception.*;
import com.evelopers.unimod.core.stateworks.*;
import com.evelopers.unimod.debug.app.AppDebugger;
import com.evelopers.unimod.debug.protocol.JavaSpecificMessageCoder;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.*;
import com.evelopers.unimod.runtime.logger.SimpleLogger;


public class WriteControllerEventProcessor extends AbstractEventProcessor {

	private ModelStructure modelStructure;

				private static final int WriteMachine = 1;
			private static final int OperationStatusMachine = 2;
	
	private int decodeStateMachine(String sm) {
					
		if ("WriteMachine".equals(sm)) {
			return WriteMachine;
						} else 
				
		if ("OperationStatusMachine".equals(sm)) {
			return OperationStatusMachine;
			}

		return -1;
	}
		
			private WriteMachineEventProcessor _WriteMachine;
			private OperationStatusMachineEventProcessor _OperationStatusMachine;
		
	public WriteControllerEventProcessor() {
		modelStructure = new WriteControllerModelStructure();

					_WriteMachine = new WriteMachineEventProcessor();
					_OperationStatusMachine = new OperationStatusMachineEventProcessor();
			}

		    public static void run(int debuggerPort, boolean debuggerSuspend) throws 
						            InterruptedException, EventProcessorException, CommonException, 
        			    IOException {

        		/* Create runtime engine */
        		ModelEngine engine = createModelEngine(true);

		        /* Setup logger */
		        final Log log = LogFactory.getLog(WriteControllerEventProcessor.class);
        		engine.getEventProcessor().addEventProcessorListener(new SimpleLogger(log));

        		/* Setup exception handler */
        		engine.getEventProcessor().addExceptionHandler(new ExceptionHandler() {
		            public void handleException(StateMachineContext context, SystemException e) {
                				log.fatal(e.getChainedMessage(), e.getRootException());
		            }
		        });

        		if (debuggerPort > 0) {
            			AppDebugger d = new AppDebugger(
            					        debuggerPort, debuggerSuspend,
                    					new JavaSpecificMessageCoder(), engine);
                    			d.start();
            		}
            		engine.start();
        	}

    	public static void main(String[] args) throws Exception {
		        int debuggerPort = NumberUtils.stringToInt(System.getProperty("debugger.port"), -1);
        		boolean debuggerSuspend = BooleanUtils.toBoolean(System.getProperty("debugger.suspend"));
        		WriteControllerEventProcessor.run(debuggerPort, debuggerSuspend);
    	}

    	public static ModelEngine createModelEngine(boolean useEventQueue) throws CommonException {
        	ObjectsManager objectsManager = new ObjectsManager();
        	return ModelEngine.createStandAlone(
        		        useEventQueue ? (EventManager) new QueuedHandler() : (EventManager) new StrictHandler(), 
        		        new WriteControllerEventProcessor(),
                objectsManager.getControlledObjectsManager(),
                objectsManager.getEventProvidersManager());
	    }

	    public static class ObjectsManager {
	        private org.cleversafe.layer.grid.smartcontroller.WriteStateMachine world = null;
	    
	        private ControlledObjectsManager controlledObjectsManager = new ControlledObjectsManagerImpl();
	        private EventProvidersManager eventProvidersManager = new EventProvidersManagerImpl();

	        public ControlledObjectsManager getControlledObjectsManager() {
	            return controlledObjectsManager;
	        }

	        public EventProvidersManager getEventProvidersManager() {
	            return eventProvidersManager;
	        }

	        private class ControlledObjectsManagerImpl implements ControlledObjectsManager {
	            public void init(ModelEngine engine) throws CommonException {}

	            public void dispose() {}

	            public ControlledObject getControlledObject(String coName) {
                if (StringUtils.equals(coName, "world")) {
                		    if (world == null) {
                		        world = new org.cleversafe.layer.grid.smartcontroller.WriteStateMachine();
                		    }
                		    return world;
                }
	                throw new IllegalArgumentException("Controlled object with name [" + coName + "] wasn't found");
	            }
	        }

	        private class EventProvidersManagerImpl implements EventProvidersManager {
	            private List nonameEventProviders = new ArrayList();

	            public void init(ModelEngine engine) throws CommonException {
	                EventProvider ep;
	            }

	            public void dispose() {
	                	EventProvider ep;
	                for (Iterator i = nonameEventProviders.iterator(); i.hasNext();) {
                    ep = (EventProvider) i.next();
                    ep.dispose();
                }
            }

	            public EventProvider getEventProvider(String epName) {
	                throw new IllegalArgumentException("Event provider with name [" + epName + "] wasn't found");
	            }
	        }
    	}
	
    public ModelStructure getModelStructure() {
		return modelStructure;
	}	
	
    public void setControlledObjectsMap(ControlledObjectsMap controlledObjectsMap) {
        super.setControlledObjectsMap(controlledObjectsMap);
		
					_WriteMachine.init(controlledObjectsMap);
					_OperationStatusMachine.init(controlledObjectsMap);
		    }

	protected StateMachineConfig process(
            Event event, StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());
		
		try {
		switch (sm) {
					case WriteMachine:
				return _WriteMachine.process(event, context, path, config);
					case OperationStatusMachine:
				return _OperationStatusMachine.process(event, context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}

    protected StateMachineConfig transiteToStableState(
            StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());

		try {
		switch (sm) {
					case WriteMachine:
				return _WriteMachine.transiteToStableState(context, path, config);
					case OperationStatusMachine:
				return _OperationStatusMachine.transiteToStableState(context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}	

	
	
private class WriteControllerModelStructure implements ModelStructure {
	    private Map configManagers = new HashMap();

    private WriteControllerModelStructure() {
		        configManagers.put("WriteMachine", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
		        configManagers.put("OperationStatusMachine", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
		    }

	    public StateMachinePath getRootPath() 
	            throws EventProcessorException {
	        	return new StateMachinePath("WriteMachine");				
	    }

	    public StateMachineConfigManager getConfigManager(String stateMachine) 
	            throws EventProcessorException {
		        return (StateMachineConfigManager)configManagers.get(stateMachine);
	    }

	    public StateMachineConfig getTopConfig(String stateMachine) 
	            throws EventProcessorException {
        		int sm = decodeStateMachine(stateMachine);
		
		        switch (sm) {
					            case WriteMachine:
                				return new StateMachineConfig("Top");
					            case OperationStatusMachine:
                				return new StateMachineConfig("Top");
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }

    	public boolean isFinal(String stateMachine, StateMachineConfig config) 
    	        throws EventProcessorException {
		        /* Get state machine from path */
        		int sm = decodeStateMachine(stateMachine);
        		int state;
		        		switch (sm) {
					            case WriteMachine:
                				state = _WriteMachine.decodeState(config.getActiveState());
				                switch (state) {
																																																																																		                    case WriteMachineEventProcessor.Success:
																				                    case WriteMachineEventProcessor.Exception:
																		                        return true;
				                    					default:
                    						    return false;
                	}
					            case OperationStatusMachine:
                				state = _OperationStatusMachine.decodeState(config.getActiveState());
				                switch (state) {
																																														                    case OperationStatusMachineEventProcessor.Operation_failure:
																													                    case OperationStatusMachineEventProcessor.Operation_success:
																		                        return true;
				                    					default:
                    						    return false;
                	}
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }			
}
	
			







private class WriteMachineEventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int Start = 2;
	    private static final int Begin_transactions = 3;
	    private static final int Transaction_status_OK = 4;
	    private static final int Determine_exception = 5;
	    private static final int Perform_write = 6;
	    private static final int Write_status_OK = 7;
	    private static final int Success = 8;
	    private static final int Exception = 9;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("Start".equals(state)) {
			return Start;
						} else 
				
		if ("Begin transactions".equals(state)) {
			return Begin_transactions;
						} else 
				
		if ("Transaction status OK".equals(state)) {
			return Transaction_status_OK;
						} else 
				
		if ("Determine exception".equals(state)) {
			return Determine_exception;
						} else 
				
		if ("Perform write".equals(state)) {
			return Perform_write;
						} else 
				
		if ("Write status OK".equals(state)) {
			return Write_status_OK;
						} else 
				
		if ("Success".equals(state)) {
			return Success;
						} else 
				
		if ("Exception".equals(state)) {
			return Exception;
			}
		
		return -1;
	}
	
		// events
	    private static final int slice_store_task_exception = 1;
	    private static final int slice_store_task_success = 2;
	    private static final int ok = 3;
	    private static final int not_ok = 4;
	    private static final int operation_completed = 5;
	
	private int decodeEvent(String event) {
					
		if ("slice_store_task_exception".equals(event)) {
			return slice_store_task_exception;
						} else 
				
		if ("slice_store_task_success".equals(event)) {
			return slice_store_task_success;
						} else 
				
		if ("ok".equals(event)) {
			return ok;
						} else 
				
		if ("not_ok".equals(event)) {
			return not_ok;
						} else 
				
		if ("operation_completed".equals(event)) {
			return operation_completed;
				}
	
		return -1;
	}
		
							private org.cleversafe.layer.grid.smartcontroller.WriteStateMachine world;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
									world = (org.cleversafe.layer.grid.smartcontroller.WriteStateMachine)controlledObjectsMap.getControlledObject("world");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case Start: 
					
											return;
																					case Begin_transactions: 
					
											return;
																					case Transaction_status_OK: 
																					// Transaction status OK includes OperationStatusMachine
	
	fireBeforeSubmachineExecution(context, event, path, "Transaction status OK", "OperationStatusMachine");
	
	WriteControllerEventProcessor.this.process(event, context, new StateMachinePath(path,
		"Transaction status OK", "OperationStatusMachine"));

    fireAfterSubmachineExecution(context, event, path, "Transaction status OK", "OperationStatusMachine");
												
											return;
																					case Determine_exception: 
					
											return;
																					case Perform_write: 
					
											return;
																					case Write_status_OK: 
																					// Write status OK includes OperationStatusMachine
	
	fireBeforeSubmachineExecution(context, event, path, "Write status OK", "OperationStatusMachine");
	
	WriteControllerEventProcessor.this.process(event, context, new StateMachinePath(path,
		"Write status OK", "OperationStatusMachine"));

    fireAfterSubmachineExecution(context, event, path, "Write status OK", "OperationStatusMachine");
												
											return;
																					case Success: 
					
											return;
																					case Exception: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [WriteMachine]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "Start");

					// Start->Begin transactions [true]/world.beginTransactions
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "Start", event, "Start#Begin transactions##true");
	
				fireBeforeOutputActionExecution(context, path, "Start#Begin transactions##true", "world.beginTransactions");

				world.beginTransactions(context);
		
	fireAfterOutputActionExecution(context, path, "Start#Begin transactions##true", "world.beginTransactions");
		
	fireComeToState(context, path, "Begin transactions");
	
	// Begin transactions [world.checkOperationCompleted]
				fireBeforeOutputActionExecution(context, path, "Start#Begin transactions##true", "world.checkOperationCompleted");

				world.checkOperationCompleted(context);
		
	fireAfterOutputActionExecution(context, path, "Start#Begin transactions##true", "world.checkOperationCompleted");
						
											return new StateMachineConfig("Begin transactions");
																																																				}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
				
		
	
				BitSet calculatedInputActions = new BitSet(0);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																										case Begin_transactions:
						
											
												switch (e) {
													case slice_store_task_exception:
																
						// Begin transactions->Transaction status OK slice_store_task_exception[true]/world.sliceStoreTaskException
			
			fireTransitionCandidate(context, path, "Begin transactions", event, "Begin transactions#Transaction status OK#slice_store_task_exception#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Begin transactions", event, "Begin transactions#Transaction status OK#slice_store_task_exception#true");
	
				fireBeforeOutputActionExecution(context, path, "Begin transactions#Transaction status OK#slice_store_task_exception#true", "world.sliceStoreTaskException");

				world.sliceStoreTaskException(context);
		
	fireAfterOutputActionExecution(context, path, "Begin transactions#Transaction status OK#slice_store_task_exception#true", "world.sliceStoreTaskException");
		
	fireComeToState(context, path, "Transaction status OK");
	
	// Transaction status OK []
					return new StateMachineConfig("Transaction status OK");

																				
														case slice_store_task_success:
																
						// Begin transactions->Begin transactions slice_store_task_success[true]/world.transactionStarted
			
			fireTransitionCandidate(context, path, "Begin transactions", event, "Begin transactions#Begin transactions#slice_store_task_success#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Begin transactions", event, "Begin transactions#Begin transactions#slice_store_task_success#true");
	
				fireBeforeOutputActionExecution(context, path, "Begin transactions#Begin transactions#slice_store_task_success#true", "world.transactionStarted");

				world.transactionStarted(context);
		
	fireAfterOutputActionExecution(context, path, "Begin transactions#Begin transactions#slice_store_task_success#true", "world.transactionStarted");
		
	fireComeToState(context, path, "Begin transactions");
	
	// Begin transactions [world.checkOperationCompleted]
				fireBeforeOutputActionExecution(context, path, "Begin transactions#Begin transactions#slice_store_task_success#true", "world.checkOperationCompleted");

				world.checkOperationCompleted(context);
		
	fireAfterOutputActionExecution(context, path, "Begin transactions#Begin transactions#slice_store_task_success#true", "world.checkOperationCompleted");
					return new StateMachineConfig("Begin transactions");

																				
														case operation_completed:
																
						// Begin transactions->Perform write operation_completed[true]/world.beginWrite
			
			fireTransitionCandidate(context, path, "Begin transactions", event, "Begin transactions#Perform write#operation_completed#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Begin transactions", event, "Begin transactions#Perform write#operation_completed#true");
	
				fireBeforeOutputActionExecution(context, path, "Begin transactions#Perform write#operation_completed#true", "world.beginWrite");

				world.beginWrite(context);
		
	fireAfterOutputActionExecution(context, path, "Begin transactions#Perform write#operation_completed#true", "world.beginWrite");
		
	fireComeToState(context, path, "Perform write");
	
	// Perform write [world.checkOperationCompleted]
				fireBeforeOutputActionExecution(context, path, "Begin transactions#Perform write#operation_completed#true", "world.checkOperationCompleted");

				world.checkOperationCompleted(context);
		
	fireAfterOutputActionExecution(context, path, "Begin transactions#Perform write#operation_completed#true", "world.checkOperationCompleted");
					return new StateMachineConfig("Perform write");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case Transaction_status_OK:
						
											
												switch (e) {
													case ok:
																
						// Transaction status OK->Begin transactions ok[true]/
			
			fireTransitionCandidate(context, path, "Transaction status OK", event, "Transaction status OK#Begin transactions#ok#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Transaction status OK", event, "Transaction status OK#Begin transactions#ok#true");
	
		
	fireComeToState(context, path, "Begin transactions");
	
	// Begin transactions [world.checkOperationCompleted]
				fireBeforeOutputActionExecution(context, path, "Transaction status OK#Begin transactions#ok#true", "world.checkOperationCompleted");

				world.checkOperationCompleted(context);
		
	fireAfterOutputActionExecution(context, path, "Transaction status OK#Begin transactions#ok#true", "world.checkOperationCompleted");
					return new StateMachineConfig("Begin transactions");

																				
														case not_ok:
																
						// Transaction status OK->Determine exception not_ok[true]/
			
			fireTransitionCandidate(context, path, "Transaction status OK", event, "Transaction status OK#Determine exception#not_ok#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Transaction status OK", event, "Transaction status OK#Determine exception#not_ok#true");
	
		
	fireComeToState(context, path, "Determine exception");
	
	// Determine exception [world.determineException]
				fireBeforeOutputActionExecution(context, path, "Transaction status OK#Determine exception#not_ok#true", "world.determineException");

				world.determineException(context);
		
	fireAfterOutputActionExecution(context, path, "Transaction status OK#Determine exception#not_ok#true", "world.determineException");
					return new StateMachineConfig("Determine exception");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case Determine_exception:
						
											
												switch (e) {
												default:
														
						// Determine exception->Exception *[true]/world.exitMachine
			
			fireTransitionCandidate(context, path, "Determine exception", event, "Determine exception#Exception#*#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Determine exception", event, "Determine exception#Exception#*#true");
	
				fireBeforeOutputActionExecution(context, path, "Determine exception#Exception#*#true", "world.exitMachine");

				world.exitMachine(context);
		
	fireAfterOutputActionExecution(context, path, "Determine exception#Exception#*#true", "world.exitMachine");
		
	fireComeToState(context, path, "Exception");
	
	// Exception []
					return new StateMachineConfig("Exception");

																				
							}
						
																						case Perform_write:
						
											
												switch (e) {
													case slice_store_task_exception:
																
						// Perform write->Write status OK slice_store_task_exception[true]/world.sliceStoreTaskException
			
			fireTransitionCandidate(context, path, "Perform write", event, "Perform write#Write status OK#slice_store_task_exception#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Perform write", event, "Perform write#Write status OK#slice_store_task_exception#true");
	
				fireBeforeOutputActionExecution(context, path, "Perform write#Write status OK#slice_store_task_exception#true", "world.sliceStoreTaskException");

				world.sliceStoreTaskException(context);
		
	fireAfterOutputActionExecution(context, path, "Perform write#Write status OK#slice_store_task_exception#true", "world.sliceStoreTaskException");
		
	fireComeToState(context, path, "Write status OK");
	
	// Write status OK []
					return new StateMachineConfig("Write status OK");

																				
														case slice_store_task_success:
																
						// Perform write->Perform write slice_store_task_success[true]/world.writeComplete
			
			fireTransitionCandidate(context, path, "Perform write", event, "Perform write#Perform write#slice_store_task_success#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Perform write", event, "Perform write#Perform write#slice_store_task_success#true");
	
				fireBeforeOutputActionExecution(context, path, "Perform write#Perform write#slice_store_task_success#true", "world.writeComplete");

				world.writeComplete(context);
		
	fireAfterOutputActionExecution(context, path, "Perform write#Perform write#slice_store_task_success#true", "world.writeComplete");
		
	fireComeToState(context, path, "Perform write");
	
	// Perform write [world.checkOperationCompleted]
				fireBeforeOutputActionExecution(context, path, "Perform write#Perform write#slice_store_task_success#true", "world.checkOperationCompleted");

				world.checkOperationCompleted(context);
		
	fireAfterOutputActionExecution(context, path, "Perform write#Perform write#slice_store_task_success#true", "world.checkOperationCompleted");
					return new StateMachineConfig("Perform write");

																				
														case operation_completed:
																
						// Perform write->Success operation_completed[true]/world.exitMachine
			
			fireTransitionCandidate(context, path, "Perform write", event, "Perform write#Success#operation_completed#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Perform write", event, "Perform write#Success#operation_completed#true");
	
				fireBeforeOutputActionExecution(context, path, "Perform write#Success#operation_completed#true", "world.exitMachine");

				world.exitMachine(context);
		
	fireAfterOutputActionExecution(context, path, "Perform write#Success#operation_completed#true", "world.exitMachine");
		
	fireComeToState(context, path, "Success");
	
	// Success []
					return new StateMachineConfig("Success");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case Write_status_OK:
						
											
												switch (e) {
													case ok:
																
						// Write status OK->Perform write ok[true]/
			
			fireTransitionCandidate(context, path, "Write status OK", event, "Write status OK#Perform write#ok#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Write status OK", event, "Write status OK#Perform write#ok#true");
	
		
	fireComeToState(context, path, "Perform write");
	
	// Perform write [world.checkOperationCompleted]
				fireBeforeOutputActionExecution(context, path, "Write status OK#Perform write#ok#true", "world.checkOperationCompleted");

				world.checkOperationCompleted(context);
		
	fireAfterOutputActionExecution(context, path, "Write status OK#Perform write#ok#true", "world.checkOperationCompleted");
					return new StateMachineConfig("Perform write");

																				
														case not_ok:
																
						// Write status OK->Determine exception not_ok[true]/
			
			fireTransitionCandidate(context, path, "Write status OK", event, "Write status OK#Determine exception#not_ok#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Write status OK", event, "Write status OK#Determine exception#not_ok#true");
	
		
	fireComeToState(context, path, "Determine exception");
	
	// Determine exception [world.determineException]
				fireBeforeOutputActionExecution(context, path, "Write status OK#Determine exception#not_ok#true", "world.determineException");

				world.determineException(context);
		
	fireAfterOutputActionExecution(context, path, "Write status OK#Determine exception#not_ok#true", "world.determineException");
					return new StateMachineConfig("Determine exception");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																															default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [WriteMachine]");
			}
		}
	}

		        
}
			







private class OperationStatusMachineEventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int s1 = 2;
	    private static final int Technical_status = 3;
	    private static final int Operation_failure = 4;
	    private static final int Policy_status = 5;
	    private static final int Operation_success = 6;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
						} else 
				
		if ("Technical status".equals(state)) {
			return Technical_status;
						} else 
				
		if ("Operation failure".equals(state)) {
			return Operation_failure;
						} else 
				
		if ("Policy status".equals(state)) {
			return Policy_status;
						} else 
				
		if ("Operation success".equals(state)) {
			return Operation_success;
			}
		
		return -1;
	}
	
		// events
	    private static final int yes = 1;
	    private static final int no = 2;
	
	private int decodeEvent(String event) {
					
		if ("yes".equals(event)) {
			return yes;
						} else 
				
		if ("no".equals(event)) {
			return no;
				}
	
		return -1;
	}
		
							private org.cleversafe.layer.grid.smartcontroller.WriteStateMachine world;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
									world = (org.cleversafe.layer.grid.smartcontroller.WriteStateMachine)controlledObjectsMap.getControlledObject("world");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case s1: 
					
											return;
																					case Technical_status: 
					
											return;
																					case Operation_failure: 
					
											return;
																					case Policy_status: 
					
											return;
																					case Operation_success: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [OperationStatusMachine]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s1");

					// s1->Technical status [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1#Technical status##true");
	
		
	fireComeToState(context, path, "Technical status");
	
	// Technical status [world.checkOperationStatusOK]
				fireBeforeOutputActionExecution(context, path, "s1#Technical status##true", "world.checkOperationStatusOK");

				world.checkOperationStatusOK(context);
		
	fireAfterOutputActionExecution(context, path, "s1#Technical status##true", "world.checkOperationStatusOK");
						
											return new StateMachineConfig("Technical status");
																																					}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
				
		
	
				BitSet calculatedInputActions = new BitSet(0);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																										case Technical_status:
						
											
												switch (e) {
													case yes:
																
						// Technical status->Policy status yes[true]/
			
			fireTransitionCandidate(context, path, "Technical status", event, "Technical status#Policy status#yes#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Technical status", event, "Technical status#Policy status#yes#true");
	
		
	fireComeToState(context, path, "Policy status");
	
	// Policy status [world.checkPolicyStatusOK]
				fireBeforeOutputActionExecution(context, path, "Technical status#Policy status#yes#true", "world.checkPolicyStatusOK");

				world.checkPolicyStatusOK(context);
		
	fireAfterOutputActionExecution(context, path, "Technical status#Policy status#yes#true", "world.checkPolicyStatusOK");
					return new StateMachineConfig("Policy status");

																				
														case no:
																
						// Technical status->Operation failure no[true]/world.fireNotOk
			
			fireTransitionCandidate(context, path, "Technical status", event, "Technical status#Operation failure#no#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Technical status", event, "Technical status#Operation failure#no#true");
	
				fireBeforeOutputActionExecution(context, path, "Technical status#Operation failure#no#true", "world.fireNotOk");

				world.fireNotOk(context);
		
	fireAfterOutputActionExecution(context, path, "Technical status#Operation failure#no#true", "world.fireNotOk");
		
	fireComeToState(context, path, "Operation failure");
	
	// Operation failure []
					return new StateMachineConfig("Operation failure");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																													case Policy_status:
						
											
												switch (e) {
													case yes:
																
						// Policy status->Operation success yes[true]/world.fireOk
			
			fireTransitionCandidate(context, path, "Policy status", event, "Policy status#Operation success#yes#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Policy status", event, "Policy status#Operation success#yes#true");
	
				fireBeforeOutputActionExecution(context, path, "Policy status#Operation success#yes#true", "world.fireOk");

				world.fireOk(context);
		
	fireAfterOutputActionExecution(context, path, "Policy status#Operation success#yes#true", "world.fireOk");
		
	fireComeToState(context, path, "Operation success");
	
	// Operation success []
					return new StateMachineConfig("Operation success");

																				
														case no:
																
						// Policy status->Operation failure no[true]/world.fireNotOk
			
			fireTransitionCandidate(context, path, "Policy status", event, "Policy status#Operation failure#no#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Policy status", event, "Policy status#Operation failure#no#true");
	
				fireBeforeOutputActionExecution(context, path, "Policy status#Operation failure#no#true", "world.fireNotOk");

				world.fireNotOk(context);
		
	fireAfterOutputActionExecution(context, path, "Policy status#Operation failure#no#true", "world.fireNotOk");
		
	fireComeToState(context, path, "Operation failure");
	
	// Operation failure []
					return new StateMachineConfig("Operation failure");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																								default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [OperationStatusMachine]");
			}
		}
	}

		        
}
	
	private static boolean isInputActionCalculated(BitSet calculatedInputActions, int k) {
		boolean b = calculatedInputActions.get(k);
            
        if (!b) {
			calculatedInputActions.set(k);
		}
            
        return b;
	}
	
}
	
