//
// Cleversafe open-source code header - Version 1.2 - February 15, 2008
//
// Cleversafe Dispersed Storage(TM) is software for secure, private and
// reliable storage of the world's data using information dispersal.
//
// Copyright (C) 2005-2008 Cleversafe, Inc.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
// USA.
//
// Contact Information: Cleversafe, 224 North Desplaines Street, Suite 500 
// Chicago IL 60661
// email licensing@cleversafe.org
//
// END-OF-HEADER
//-----------------------
// Author: mmotwani
//
// Date: Jun 1, 2007
//---------------------

package org.cleversafe.layer.protocol;

/**
 * Interface for protocol messages that represent responses sent from the server to the client.
 * 
 * @see Request
 * @see UnsolicitedMessage
 * @see ProtocolMessage
 */
public interface Response extends ProtocolMessage
{
   /**
    * Returns true if the exception flag is set, false otherwise.
    * 
    * @return The exception flag.
    */
   public boolean getExceptionFlag();

   /**
    * Returns the original exception that was caught during request handling or response creation.
    * 
    * @return The original exception.
    */
   public Exception getException();

   /**
    * Sets the original exception that was caught during request handling or response creation.
    * 
    * @param exception
    *           The original exception.
    */
   public void setException(Exception exception);
}
